<template>
  <div class="post-edit">
    <div class="content">
      <h1>Edit a New Post - {{ post.id }}</h1>
      <PostForm :post="post" @submit="onPostSubmitted" />
    </div>
  </div>
</template>
<script>
import FireStoreParser from 'firestore-parser'
export default {
  layout: 'blog',
  asyncData(context) {
    const structuredQuery = {
      from: [
        {
          collectionId: 'posts',
        },
      ],
      where: {
        fieldFilter: {
          field: {
            fieldPath: 'slug',
          },
          op: 'EQUAL',
          value: {
            stringValue: context.params.slug,
          },
        },
      },
    }
    return context.app.$axios
      .post(
        'https://firestore.googleapis.com/v1/projects/my-awesome-nuxt-project/databases/(default)/documents/:runQuery',
        { structuredQuery }
      )
      .then((result) => {
        const data = FireStoreParser(result.data[0])
        const post = {
          ...data.document.fields,
          id: data.document.name.substring(
            data.document.name.lastIndexOf('/') + 1
          ),
        }
        return { post }
      })
      .catch((error) => {
        // eslint-disable-next-line no-console
        console.error(error)
      })
  },
  methods: {
    onPostSubmitted(submittedPost) {
      // eslint-disable-next-line no-console
      console.log('Thank you for Submitting', submittedPost)
      this.$store.dispatch('posts/editPost', submittedPost).then(() => {
        this.$router.push('/')
      })
    },
  },
}
</script>
<style>
.post-edit {
  max-width: 800px;
  position: relative;
  background-color: #ddd;
  margin: 0 auto;
  margin-top: 4.25rem;
}
.content {
  width: 100%;
  margin: 10px 0;
  padding: 20px;
}
</style>
